﻿using System;
using System.Windows.Forms;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.WinForms;

namespace _8861
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;

            LayerOverlay layerOverlay = new LayerOverlay();
            ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(@"..\..\AppData\states.shp");
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = WorldStreetsAreaStyles.Military();
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            layerOverlay.Layers.Add(shapeFileLayer);
            winformsMap1.Overlays.Add(layerOverlay);

            shapeFileLayer.Open();
            winformsMap1.CurrentExtent = shapeFileLayer.GetBoundingBox();
            winformsMap1.Refresh();
        }
    }

    public class CustomTrackInteractiveOverlay : TrackInteractiveOverlay
    {
        protected override InteractiveResult MouseMoveCore(InteractionArguments interactionArguments)
        {
            InteractiveResult interactiveResult = base.MouseMoveCore(interactionArguments);
            ModifyFeature();

            return interactiveResult;
        }

        private void ModifyFeature()
        {
            if (TrackShapeLayer.InternalFeatures.Count > 0)
            {
                Feature feature = TrackShapeLayer.InternalFeatures[TrackShapeLayer.InternalFeatures.Count - 1];
                switch (TrackMode)
                {
                    case TrackMode.Custom:
                        BaseShape baseShape = feature.GetShape();


                        // Modify the feature here to make it follow your rule

                        break;
                    default:
                        break;
                }

                TrackShapeLayer.InternalFeatures[TrackShapeLayer.InternalFeatures.Count - 1] = feature;
            }
        }
    }
}
